# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free

Name:           ops4j-pax-swissbox
Summary:        Pax OSGi swissbox
Url:            http://wiki.ops4j.org/display/PAXSB/Pax+Swissbox
Version:        1.3.0
Release:        2%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-pax-swissbox-1.3.0.tgz
# svn export http://scm.ops4j.org/repos/ops4j/qa/pax/swissbox-1.3.0/ ops4j-pax-swissbox-1.3.0
# tar czf ops4j-pax-swissbox-1.3.0.tgz ops4j-pax-swissbox-1.3.0/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         ops4j-pax-swissbox-pom.patch
Patch1:         ops4j-pax-swissbox-converter-osgi-bnd.patch
Patch2:         ops4j-pax-swissbox-samples-tinybundles-pom.patch
Patch3:         ops4j-pax-swissbox-BndUtils.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-bundle-plugin

BuildRequires:  ops4j-pax-master
BuildRequires:  ops4j-base

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  ops4j-pax-master
Requires:  ops4j-base

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Pax Swissbox is a set of utilities targeting OSGi and the 
project emerged as means for re-usage within Pax projects.
But, as Pax Swissbox artifacts are generic, they can be 
reused outside Pax projects.
In order to minimize dependencies and improve modularity Pax
Swissbox is split in very fine grained bundles that you can
use individually. Pax Swissbox artifacts are meant to be
embedded (wrapped) in your bundle (easy to achieve using
Maven Bundle Plugin) but you can use them as standalone
bundles.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -P release \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -P release \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.ops4j.pax swissbox %{version} JPP/%{name} swissbox
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox.pom

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-bnd %{version} JPP/%{name} swissbox-bnd
install -m 644 pax-swissbox-bnd/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-bnd.pom
install -m 644 pax-swissbox-bnd/target/pax-swissbox-bnd-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-bnd-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-converter %{version} JPP/%{name} swissbox-converter
install -m 644 pax-swissbox-converter/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-converter.pom
install -m 644 pax-swissbox-converter/target/pax-swissbox-converter-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-converter-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-core %{version} JPP/%{name} swissbox-core
install -m 644 pax-swissbox-core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-core.pom
install -m 644 pax-swissbox-core/target/pax-swissbox-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-core-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-extender %{version} JPP/%{name} swissbox-extender
install -m 644 pax-swissbox-extender/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-extender.pom
install -m 644 pax-swissbox-extender/target/pax-swissbox-extender-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-extender-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-lifecycle %{version} JPP/%{name} swissbox-lifecycle
install -m 644 pax-swissbox-lifecycle/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-lifecycle.pom
install -m 644 pax-swissbox-lifecycle/target/pax-swissbox-lifecycle-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-lifecycle-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-optional-jcl %{version} JPP/%{name} swissbox-optional-jcl
install -m 644 pax-swissbox-optional-jcl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-optional-jcl.pom
install -m 644 pax-swissbox-optional-jcl/target/pax-swissbox-optional-jcl-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-optional-jcl-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-property %{version} JPP/%{name} swissbox-property
install -m 644 pax-swissbox-property/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-property.pom
install -m 644 pax-swissbox-property/target/pax-swissbox-property-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-property-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-tinybundles %{version} JPP/%{name} swissbox-tinybundles
install -m 644 pax-swissbox-tinybundles/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-tinybundles.pom
install -m 644 pax-swissbox-tinybundles/target/pax-swissbox-tinybundles-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-tinybundles-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.swissbox pax-swissbox-tracker %{version} JPP/%{name} swissbox-tracker
install -m 644 pax-swissbox-tracker/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-swissbox-tracker.pom
install -m 644 pax-swissbox-tracker/target/pax-swissbox-tracker-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/swissbox-tracker-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Sun Feb 05 2012 Ralph Apel <r.apel at r-apel.de> 0:1.3.0-2
- Promote to free

* Sat Jun 18 2011 Ralph Apel <r.apel at r-apel.de> 0:1.3.0-1
- First standalone release
